/*
 * Helper functions for formatting --help program output.
 *
 * Copyright © 2021-2024 Nick Bowler
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
/*
 * If ENABLE_NLS is defined to 1, then translations are supported via gettext.
 *
 * If HAVE_MBRTOWC and HAVE_WCWIDTH are both defined to 1, then the mbrtowc
 * and wcwidth functions will be used to try and properly align the help output
 * of translated option strings when ENABLE_NLS is set.  Otherwise everything
 * should still work but there may be minor output alignment issues.  The
 * DX_CHECK_MBRTOWC_WCWIDTH macro may be used to probe for these functions.
 *
 * If HELP_GETOPT_LONG_ONLY is defined to 1, then the output is simplified
 * for programs which use getopt_long_only: short options are not displayed,
 * long options are displayed with a single hyphen, and no equals sign is
 * displayed between options and their arguments.
 */

#if HAVE_CONFIG_H
#  include <config.h>
#endif
#include <stdio.h>
#include <stddef.h>
#include <string.h>
#include <limits.h>

/* Include this before defining struct option below to avoid issue on VAX C. */
#include "help.h"

#if HAVE_GETOPT_LONG || HAVE_GETOPT_LONG_ONLY
#  include <getopt.h>
#else
struct option {
	const char *name;
	int has_arg, *flag, val;
};
#endif

#ifndef ENABLE_NLS
#  define ENABLE_NLS 0
#endif
#ifndef HELP_GETOPT_LONG_ONLY
#  define HELP_GETOPT_LONG_ONLY 0
#endif

#if ENABLE_NLS
#  include <locale.h>
#  include <libintl.h>

/*
 * When NLS is enabled, we assume snprintf is available.  The GNU libintl
 * library should provide a suitable fallback if necessary.
 */
#  ifndef help_do_snprintf
#    define help_do_snprintf(x) snprintf x
#  endif

/*
 * We provide our own pgettext_expr workalike as we can assume the
 * messages are short.
 */
static const char *
do_pgettext(const struct option *opt, const char *msg)
{
	if (opt && msg) {
		const char *t;
		char buf[256];

		help_do_snprintf((buf, sizeof buf, "%s\004%s", opt->name, msg));
		if ((t = gettext(buf)) != buf)
			return t;
	}

	return msg;
}

#  if HAVE_MBRTOWC && HAVE_WCWIDTH
#    include <wchar.h>

static int do_mbsnwidth(const char *buf, size_t buflen)
{
	mbstate_t ps;
	int ret = 0;

	memset(&ps, 0, sizeof ps);
	while (buflen > 0) {
		wchar_t wc;
		size_t l;
		int w;

		l = mbrtowc(&wc, buf, buflen, &ps);
		if (l == (size_t)-1 || l == (size_t)-2)
			return -1;
		else if (l == 0)
			break;

		buflen -= l;
		buf += l;

		w = wcwidth(wc);
		if (w < 0)
			return -1;
		ret += w;
	}

	return ret;
}
#  else /* !HAVE_MBRTOWC || !HAVE_WCWIDTH */
#    define do_mbsnwidth(buf, buflen) (buflen)
#  endif
#else /* !ENABLE_NLS */
#  define gettext(s) (s)
#  define do_pgettext(ctx, msg) ((void)(ctx), (msg))
#  define do_mbsnwidth(a, b) ((void)(a, b), 0)
#  define help_do_snprintf(x) ((void)x, 0)
#endif

/* Returns a single numeric value depending on the type of option:
 *
 *   6 - if the option has a short option character and an optional argument
 *   5 - if the option has a short option character and a mandatory argument
 *   4 - if the option has a short option charater and no argument
 *   3 - N/A
 *   2 - if the option has no short option character and an optional argument
 *   1 - if the option has no short option character and a mandatory argument
 *   0 - if the option has no short option character and no argument
 */
static int option_type(const struct option *opt)
{
	int ret = opt->has_arg & 3;

#if !HELP_GETOPT_LONG_ONLY
	if (!opt->flag)
		ret |= (opt->val <= CHAR_MAX) << 2;
#endif

	return ret;
}

enum {
	OPT_SHORT_WITH_OPTIONAL_ARG  = 6,
	OPT_SHORT_WITH_MANDATORY_ARG = 5,
	OPT_SHORT_WITHOUT_ARG        = 4,
	OPT_LONG_WITH_OPTIONAL_ARG   = 2,
	OPT_LONG_WITH_MANDATORY_ARG  = 1,
	OPT_LONG_WITHOUT_ARG         = 0
};

#if HELP_GETOPT_LONG_ONLY
/* String table generated by gen-strtab.awk from help-glo.str */

#define STRTAB_INITIALIZER "\
 -%s [%s]\0\
%*s%.*s\n\0\
 -%s %s\0\
 -%s"

#if 0
	gettext(" -%s [%s]");
	gettext(" -%s");
	gettext(" -%s %s");
#endif

enum {
	fmt_long_optional_arg = 0,
	fmt_long_without_arg = 27,
	fmt_long_mandatory_arg = 19,
	fmt_desc = 10,
	fmt_nl = 17
};

#else
/* String table generated by gen-strtab.awk from help-std.str */

#define STRTAB_INITIALIZER "\
 -%c, --%s[=%s]\0\
 -%c, --%s=%s\0\
 -%c, --%s\0\
%*s%.*s\n"

#if 0
	gettext(" --%s[=%s]");
	gettext(" --%s");
	gettext(" --%s=%s");
	gettext(" -%c, --%s");
	gettext(" -%c, --%s=%s");
	gettext(" -%c, --%s[=%s]");
#endif

enum {
	fmt_long_optional_arg = 5,
	fmt_long_without_arg = 35,
	fmt_long_mandatory_arg = 21,
	fmt_short_without_arg = 30,
	fmt_short_mandatory_arg = 16,
	fmt_desc = 41,
	fmt_nl = 48,
	fmt_short_optional_arg = 0
};
#endif

static const struct optstr {
	unsigned char map[HELP_GETOPT_LONG_ONLY ? 3 : 7];
	char tab[sizeof (STRTAB_INITIALIZER)];
} optstr = {
	{
		offsetof(struct optstr, tab) + fmt_long_without_arg,
		offsetof(struct optstr, tab) + fmt_long_mandatory_arg,
		offsetof(struct optstr, tab) + fmt_long_optional_arg,
#if !HELP_GETOPT_LONG_ONLY
		0,
		offsetof(struct optstr, tab) + fmt_short_without_arg,
		offsetof(struct optstr, tab) + fmt_short_mandatory_arg,
		offsetof(struct optstr, tab) + fmt_short_optional_arg,
#endif
	},
	STRTAB_INITIALIZER
};

#define has_short_char(type) (!HELP_GETOPT_LONG_ONLY && (type & 4))

int help_print_optstring(const struct option *opt, const char *argname, int l)
{
	int type = option_type(opt);
	const char *fmt, *nls_arg;
	char optstring[256];
	int w;

	fmt = (char *)&optstr + optstr.map[type];
	if (!ENABLE_NLS)
		goto no_translate;

	nls_arg = do_pgettext(opt, argname);
	if (has_short_char(type)) {
		w = help_do_snprintf((optstring, sizeof optstring,
		                      gettext(fmt), opt->val, opt->name,
				      nls_arg));
	} else {
		w = help_do_snprintf((optstring, sizeof optstring,
		                      gettext(fmt), opt->name,
		                      nls_arg));
	}

	if (w < 0 || w >= sizeof optstring)
		goto no_translate;

	w = do_mbsnwidth(optstring, w);
	printf("%s", optstring);
	goto out;

no_translate:
	if (has_short_char(type)) {
		w = printf(fmt, opt->val, opt->name, argname);
	} else {
		w = printf(fmt, opt->name, argname);
	}
out:
	if (w <= 0 || w > l) {
		putchar('\n');
		return 0;
	}

	return w;
}

void help_print_desc(const struct option *opt, const char *s, int i, int w)
{
	/*
	 * For an option with an empty help string, use the option name
	 * as context to allow translators to introduce descriptions.
	 */
	if (!s[0])
		s = do_pgettext(opt, s);
	else
		s = gettext(s);

	do {
		size_t n = strcspn(s, &optstr.tab[fmt_nl]);

		printf(&optstr.tab[fmt_desc], n ? i-w : 0, "", (int)n, s);
		s += n + (s[n] != '\0');
		w = 0;
	} while (*s);
}
